=== added directory 'stock_picking_cancel'
=== added file 'stock_picking_cancel/__init__.py'
--- stock_picking_cancel/__init__.py	1970-01-01 00:00:00 +0000
+++ stock_picking_cancel/__init__.py	2012-08-06 15:39:03 +0000
@@ -0,0 +1,26 @@
+# -*- encoding: utf-8 -*-
+###########################################################################
+#    Module Writen to OpenERP, Open Source Management Solution
+#
+#    Copyright (c) 2010 Vauxoo - http://www.vauxoo.com/
+#    All Rights Reserved.
+#    info Vauxoo (info@vauxoo.com)
+############################################################################
+#    Coded by: Luis Torres (luis_t@vauxoo.com)
+############################################################################
+#
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU Affero General Public License as
+#    published by the Free Software Foundation, either version 3 of the
+#    License, or (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU Affero General Public License for more details.
+#
+#    You should have received a copy of the GNU Affero General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+##############################################################################
+import stock

=== added file 'stock_picking_cancel/__openerp__.py'
--- stock_picking_cancel/__openerp__.py	1970-01-01 00:00:00 +0000
+++ stock_picking_cancel/__openerp__.py	2012-08-06 15:39:03 +0000
@@ -0,0 +1,43 @@
+# -*- encoding: utf-8 -*-
+###########################################################################
+#    Module Writen to OpenERP, Open Source Management Solution
+#
+#    Copyright (c) 2010 Vauxoo - http://www.vauxoo.com/
+#    All Rights Reserved.
+#    info Vauxoo (info@vauxoo.com)
+############################################################################
+#    Coded by: Luis Torres (luis_t@vauxoo.com)
+############################################################################
+#
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU Affero General Public License as
+#    published by the Free Software Foundation, either version 3 of the
+#    License, or (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU Affero General Public License for more details.
+#
+#    You should have received a copy of the GNU Affero General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+##############################################################################
+{
+    "name" : "Stock Picking Cancel",
+    "version" : "1.0",
+    "author" : "Vauxoo",
+    "category" : "Stock",
+    "description" : """This module add a button to cancel after to done""",
+    "website" : "http://www.vauxoo.com/",
+    "license" : "AGPL-3",
+    "depends" : ["stock",],
+    "init_xml" : [],
+    "demo_xml" : [],
+    "update_xml" : [
+        "stock_workflow.xml",
+        "stock_view.xml",
+    ],
+    "installable" : True,
+    "active" : False,
+}

=== added file 'stock_picking_cancel/stock.py'
--- stock_picking_cancel/stock.py	1970-01-01 00:00:00 +0000
+++ stock_picking_cancel/stock.py	2012-08-06 15:39:03 +0000
@@ -0,0 +1,48 @@
+# -*- encoding: utf-8 -*-
+###########################################################################
+#    Module Writen to OpenERP, Open Source Management Solution
+#
+#    Copyright (c) 2010 Vauxoo - http://www.vauxoo.com/
+#    All Rights Reserved.
+#    info Vauxoo (info@vauxoo.com)
+############################################################################
+#    Coded by: Luis Torres (luis_t@vauxoo.com)
+############################################################################
+#
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU Affero General Public License as
+#    published by the Free Software Foundation, either version 3 of the
+#    License, or (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU Affero General Public License for more details.
+#
+#    You should have received a copy of the GNU Affero General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+##############################################################################
+from osv import osv, fields
+
+class stock_picking(osv.osv):
+    _inherit = 'stock.picking'
+    
+    def button_draft(self, cr, uid, ids, context=None):
+        print 'holaaaaaaaaaaaaaaaaaaaaaaaaaaaaa'
+        if not len(ids):
+            return False
+        cr.execute('select id from sale_order_line where order_id IN %s and state=%s', (tuple(ids), 'cancel'))
+        line_ids = map(lambda x: x[0], cr.fetchall())
+        self.write(cr, uid, ids, {'state': 'draft', 'invoice_ids': [], 'shipped': 0})
+        self.pool.get('sale.order.line').write(cr, uid, line_ids, {'invoiced': False, 'state': 'draft', 'invoice_lines': [(6, 0, [])]})
+        wf_service = netsvc.LocalService("workflow")
+        for inv_id in ids:
+            # Deleting the existing instance of workflow for SO
+            wf_service.trg_delete(uid, 'sale.order', inv_id, cr)
+            wf_service.trg_create(uid, 'sale.order', inv_id, cr)
+        for (id,name) in self.name_get(cr, uid, ids):
+            message = _("The sales order '%s' has been set in draft state.") %(name,)
+            self.log(cr, uid, id, message)
+        return True
+stock_picking()

=== added file 'stock_picking_cancel/stock_view.xml'
--- stock_picking_cancel/stock_view.xml	1970-01-01 00:00:00 +0000
+++ stock_picking_cancel/stock_view.xml	2012-08-06 15:39:03 +0000
@@ -0,0 +1,47 @@
+<?xml version="1.0" encoding="utf-8"?>
+<openerp>
+    <data>
+        <record id="view_picking_inherit_picking_cancel_form" model="ir.ui.view">
+            <field name="name">view.picking.inherit.picking.cancel.form</field>
+            <field name="model">stock.picking</field>
+            <field name="type">form</field>
+            <field name="inherit_id" ref="stock.view_picking_form"/>
+            <field name="arch" type="xml">
+                <xpath expr="/form/notebook/page[@string='Products']/group/button[@name='button_cancel']" position="replace">
+                    <button name="button_cancel" states="assigned,confirmed,draft,done" string="_Cancel" icon="gtk-cancel"/>
+                </xpath>
+                <xpath expr="/form/notebook/page[@string='Products']/group/field[@name='state']" position="after">
+                    <button name="button_draft" states="cancel" string="_Draft" type="object" icon="gtk-go-forward"/>
+                </xpath>
+            </field>
+        </record>
+        <record model="ir.ui.view" id="view_picking_inherit_picking_in_cancel_form">
+            <field name="name">view.picking.inherit.picking.in.cancel.form</field>
+            <field name="model">stock.picking</field>
+            <field name="type">form</field>
+            <field name="inherit_id" ref="stock.view_picking_in_form"/>
+            <field name="arch" type="xml">
+                <xpath expr="/form/notebook/page[@string='General Information']/group/button[@name='button_cancel']" position="replace">
+                    <button name="button_cancel" states="assigned,confirmed,draft,done" string="_Cancel" icon="gtk-cancel"/>
+                </xpath>
+                <xpath expr="/form/notebook/page[@string='General Information']/group/field[@name='state']" position="after">
+                    <button name="button_draft" states="cancel" string="_Draft" icon="gtk-go-forward"/>
+                </xpath>
+            </field>
+        </record>
+        <record model="ir.ui.view" id="view_picking_inherit_picking_out_cancel_form">
+            <field name="name">view.picking.inherit.picking.out.cancel.form</field>
+            <field name="model">stock.picking</field>
+            <field name="type">form</field>
+            <field name="inherit_id" ref="stock.view_picking_out_form"/>
+            <field name="arch" type="xml">
+                <xpath expr="/form/notebook/page[@string='Products']/group/button[@name='button_cancel']" position="replace">
+                    <button name="button_cancel" states="assigned,confirmed,draft,done" string="_Cancel" icon="gtk-cancel"/>
+                </xpath>
+                <xpath expr="/form/notebook/page[@string='Products']/group/field[@name='state']" position="after">
+                    <button name="button_draft" states="cancel" string="_Draft" icon="gtk-go-forward"/>
+                </xpath>
+            </field>
+        </record>
+    </data>
+</openerp>

=== added file 'stock_picking_cancel/stock_workflow.xml'
--- stock_picking_cancel/stock_workflow.xml	1970-01-01 00:00:00 +0000
+++ stock_picking_cancel/stock_workflow.xml	2012-08-06 15:39:03 +0000
@@ -0,0 +1,13 @@
+<?xml version="1.0" encoding="utf-8"?>
+<openerp>
+    <data>
+        <record id="stock.act_done" model="workflow.activity">
+            <field name="flow_stop"></field>
+        </record>
+        <record id="trans_done_cancel" model="workflow.transition">
+            <field name="act_from" ref="stock.act_done"/>
+            <field name="act_to" ref="stock.act_cancel"/>
+            <field name="signal">button_cancel</field>
+        </record>
+    </data>
+</openerp>

